Loading...
Searching...
No Matches
casacore::MCRadialVelocity Class Reference
measures package (libcasa_measures) » Measures_module » Measures_module_internal_classes

More...

`#include <MCRadialVelocity.h>`

## Public Member Functions

| MCRadialVelocity ()
| Default constructor.
| ~MCRadialVelocity ()
Public Member Functions inherited from casacore::MCBase
virtual | ~MCBase ()

## Static Public Member Functions

static String | showState ()
| Show the state of the conversion engine (mainly for debugging purposes).

## Private Types

enum | Routes { LSRD_BARY , BARY_LSRD , BARY_GEO , GEO_TOPO , GEO_BARY , TOPO_GEO , LSRD_GALACTO , GALACTO_LSRD , LSRK_BARY , BARY_LSRK , BARY_LGROUP , LGROUP_BARY , BARY_CMB , CMB_BARY , N_Routes }
| The list of actual routines provided. More...

## Private Member Functions

| MCRadialVelocity (const MCRadialVelocity &other)
| Copy constructor (not implemented).
MCRadialVelocity & | operator= (const MCRadialVelocity &other)
| Assignment (not implemented).
virtual void | getConvert (MConvertBase &mc, const MRBase &inref, const MRBase &outref)
| Create conversion function pointer.
virtual void | initConvert (uInt which, MConvertBase &mc)
| Create help structures for Measure conversion routines.
virtual void | clearConvert ()
| Delete the pointers used in the MeasConvert help structure cache.
virtual void | doConvert (MeasValue &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Routine to convert RadialVelocity from one reference frame to another.
void | doConvert (MVRadialVelocity &in, MRBase &inref, MRBase &outref, const MConvertBase &mc)
| Conversion routine to cater for inheritance question.

## Static Private Member Functions

static void | doFillState ()
| Fill the global state.

## Private Attributes

MVPosition * | MVPOS1
MVDirection * | MVDIR1
Aberration * | ABERFROM
Aberration * | ABERTO

## Static Private Attributes

static uInt | ToRef_p [N_Routes][3]
| Transition list.
static uInt | FromTo_p [MRadialVelocity::N_Types][MRadialVelocity::N_Types]
| Transition matrix.
static std::once_flag | theirInitOnceFlag
| Object to ensure safe multi-threaded lazy single initialization.

## Friends

class | MeasConvert< MRadialVelocity >
| Conversion of data.

## Additional Inherited Members

Public Types inherited from casacore::MCBase
enum | Routes { N_Routes }
| Each derived class should have a list of routines to be called: More...
Static Protected Member Functions inherited from casacore::MCBase
static void | makeState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| The following routines create a state transition matrix from a list of all defined transitions.
static String | showState (uInt *state, const uInt ntyp, const uInt nrout, const uInt list[][3])
| Return a fromatted String with matrix information (based on < 100 types).

## Detailed Description

MRadialVelocity conversion routines

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tMeasure

### Prerequisite

- Measure class
- MCBase base class
- overall conversion class

### Etymology

Measure, Convert and RadialVelocity

### Synopsis

Contains state machinery and cashing for actual conversions

### Example

Get the Doppler shift for an oberved HI RadialVelocity of 100 km/s

#include <casacore/measures/Measures.h>
#include <casacore/measures/Measures/MRadialVelocity.h>
#include <casacore/measures/Measures/MDoppler.h>
cout << "Redshift for 100 km/s: " <<
MDoppler::Convert(MRadialVelocity(Quantity(100., "km/s"),
MRadialVelocity::TOPO).toDoppler(QC::HI),
MDoppler::Z)() << endl;
casacore::MDoppler::Convert
MeasConvert< MDoppler > Convert
Measure Convert (i.e.
Definition MDoppler.h:165
casacore::MDoppler::Z
@ Z
Definition MDoppler.h:148
casacore::MRadialVelocity
Definition MRadialVelocity.h:134
casacore::MRadialVelocity::TOPO
@ TOPO
Definition MRadialVelocity.h:154
casacore::QC::HI
static const Quantum< Double > & HI()
HI line.
Definition QC.h:186
casacore::Quantity
Quantum< Double > Quantity
Definition Quantum.h:39

### Motivation

Definition at line 90 of file MCRadialVelocity.h.

## Member Enumeration Documentation

## Routes

enum casacore::MCRadialVelocity::Routes

private

The list of actual routines provided.

Warning: Each AA_BB in the list points to routine that can be used in the FromTo list in the getConvert routine; In addition the type to which each is converted should be in the ToRef array, again in the proper order;

Enumerator
LSRD_BARY |
BARY_LSRD |
BARY_GEO |
GEO_TOPO |
GEO_BARY |
TOPO_GEO |
LSRD_GALACTO |
GALACTO_LSRD |
LSRK_BARY |
BARY_LSRK |
BARY_LGROUP |
LGROUP_BARY |
BARY_CMB |
CMB_BARY |
N_Routes |

Definition at line 115 of file MCRadialVelocity.h.

## Constructor & Destructor Documentation

## MCRadialVelocity() [1/2]

casacore::MCRadialVelocity::MCRadialVelocity | ( |  | ) |

Default constructor.

Referenced by MCRadialVelocity(), MeasConvert< MRadialVelocity >, and operator=().

## ~MCRadialVelocity()

casacore::MCRadialVelocity::~MCRadialVelocity | ( |  | ) |

## MCRadialVelocity() [2/2]

casacore::MCRadialVelocity::MCRadialVelocity | ( | const MCRadialVelocity & | other | ) |

private

Copy constructor (not implemented).

References MCRadialVelocity().

## Member Function Documentation

## clearConvert()

virtual void casacore::MCRadialVelocity::clearConvert | ( |  | ) |

private virtual

Delete the pointers used in the MeasConvert help structure cache.

Implements casacore::MCBase.

## doConvert() [1/2]

virtual void casacore::MCRadialVelocity::doConvert | ( | MeasValue & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private virtual

Routine to convert RadialVelocity from one reference frame to another.

Implements casacore::MCBase.

## doConvert() [2/2]

void casacore::MCRadialVelocity::doConvert | ( | MVRadialVelocity & | in,
|  | MRBase & | inref,
|  | MRBase & | outref,
|  | const MConvertBase & | mc )

private

Conversion routine to cater for inheritance question.

## doFillState()

void casacore::MCRadialVelocity::doFillState | ( |  | ) |

static private

Fill the global state.

Called using theirInitOnce.

## getConvert()

virtual void casacore::MCRadialVelocity::getConvert | ( | MConvertBase & | mc,
|  | const MRBase & | inref,
|  | const MRBase & | outref )

private virtual

Create conversion function pointer.

Implements casacore::MCBase.

## initConvert()

virtual void casacore::MCRadialVelocity::initConvert | ( | uInt | which,
|  | MConvertBase & | mc )

private virtual

Create help structures for Measure conversion routines.

Implements casacore::MCBase.

## operator=()

MCRadialVelocity & casacore::MCRadialVelocity::operator= | ( | const MCRadialVelocity & | other | ) |

private

Assignment (not implemented).

References MCRadialVelocity().

## showState()

String casacore::MCRadialVelocity::showState | ( |  | ) |

static

Show the state of the conversion engine (mainly for debugging purposes).

## Friends And Related Symbol Documentation

## MeasConvert< MRadialVelocity >

friend class MeasConvert< MRadialVelocity >

friend

Conversion of data.

Definition at line 1 of file MCRadialVelocity.h.

References MCRadialVelocity().

## Member Data Documentation

## ABERFROM

Aberration* casacore::MCRadialVelocity::ABERFROM

private

Definition at line 143 of file MCRadialVelocity.h.

## ABERTO

Aberration* casacore::MCRadialVelocity::ABERTO

private

Definition at line 144 of file MCRadialVelocity.h.

## FromTo_p

uInt casacore::MCRadialVelocity::FromTo_p[MRadialVelocity::N_Types][MRadialVelocity::N_Types]

static private

Transition matrix.

Definition at line 150 of file MCRadialVelocity.h.

## MVDIR1

MVDirection* casacore::MCRadialVelocity::MVDIR1

private

Definition at line 142 of file MCRadialVelocity.h.

## MVPOS1

MVPosition* casacore::MCRadialVelocity::MVPOS1

private

Definition at line 141 of file MCRadialVelocity.h.

## theirInitOnceFlag

std::once_flag casacore::MCRadialVelocity::theirInitOnceFlag

static private

Object to ensure safe multi-threaded lazy single initialization.

Definition at line 152 of file MCRadialVelocity.h.

## ToRef_p

uInt casacore::MCRadialVelocity::ToRef_p[N_Routes][3]

static private

Transition list.

Definition at line 148 of file MCRadialVelocity.h.

The documentation for this class was generated from the following file:

- measures/Measures/MCRadialVelocity.h